



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>DRF 分页组件</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">DRF 分页组件</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-13 20:18:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>Django Rest Framework 分页组件</h1>
<h2>DRF的分页</h2>
<h3>为什么要使用分页</h3>
<p>其实这个不说大家都知道，大家写项目的时候也是一定会用的，</p>
<p>我们数据库有几千万条数据，这些数据需要展示，我们不可能直接从数据库把数据全部读取出来，</p>
<p>这样会给内存造成特别大的压力，有可能还会内存溢出，所以我们希望一点一点的取，</p>
<p>那展示的时候也是一样的，总是要进行分页显示，我们之前自己都写过分页。</p>
<p>那么大家想一个问题，在数据量特别大的时候，我们的分页会越往后读取速度越慢，</p>
<p>当有一千万条数据，我要看最后一页的内容的时候，怎么能让我的查询速度变快。</p>
<p>DRF给我们提供了三种分页方式，我们看下他们都是什么样的~~</p>
<p>分页组件的使用</p>
<p>DRF提供的三种分页</p>
<div>
<pre class="prettyprint linenums">from rest_framework.pagination import PageNumberPagination, LimitOffsetPagination, CursorPagination</pre>
</div>
<p>全局配置</p>
<div>
<pre class="prettyprint linenums">REST_FRAMEWORK = {<br />
    'PAGE_SIZE': 2<br />
}</pre>
</div>
<h4>第一种 PageNumberPagination&nbsp; 看第n页，每页显示n条数据</h4>
<p>http://127.0.0.1:8000/book?page=2&amp;size=1</p>
<div>
<div>
<pre class="prettyprint linenums">class MyPageNumber(PageNumberPagination):<br />
    page_size = 2  # 每页显示多少条<br />
    page_size_query_param = 'size'  # URL中每页显示条数的参数<br />
    page_query_param = 'page'  # URL中页码的参数<br />
    max_page_size = None  # 最大页码数限制</pre>
</div>
<p>自定义分页类</p></div>
<div>
<div>
<pre class="prettyprint linenums">class BookView(APIView):<br />
    def get(self, request):<br />
        book_list = Book.objects.all()<br />
        # 分页<br />
        page_obj = MyPageNumber()<br />
        page_article = page_obj.paginate_queryset(queryset=book_list, request=request, view=self)

        ret = BookSerializer(page_article, many=True)<br />
        return Response(ret.data)</pre>
</div>
<p>视图</p></div>
<div>
<div>
<pre class="prettyprint linenums">class BookView(APIView):<br />
    def get(self, request):<br />
        book_list = Book.objects.all()<br />
        # 分页<br />
        page_obj = MyPageNumber()<br />
        page_article = page_obj.paginate_queryset(queryset=book_list, request=request, view=self)

        ret = BookSerializer(page_article, many=True)<br />
        # return Response(ret.data)<br />
        # 返回带超链接 需返回的时候用内置的响应方法<br />
        return page_obj.get_paginated_response(ret.data)</pre>
</div>
<p>返回带页码链接的响应</p></div>
<h4>第二种 LimitOffsetPagination 在第n个位置&nbsp; 向后查看n条数据</h4>
<p>http://127.0.0.1:8000/book?offset=2&amp;limit=1</p>
<div>
<div>
<pre class="prettyprint linenums">class MyLimitOffset(LimitOffsetPagination):<br />
    default_limit = 1<br />
    limit_query_param = 'limit'<br />
    offset_query_param = 'offset'<br />
    max_limit = 999</pre>
</div>
<p>自定义的分页类</p></div>
<div>
<div>
<pre class="prettyprint linenums"># 视图和上面的大体一致<br />
# 只有用的分页类不同，其他都相同<br />
class BookView(APIView):<br />
    def get(self, request):<br />
        book_list = Book.objects.all()<br />
        # 分页<br />
        page_obj = MyLimitOffset()<br />
        page_article = page_obj.paginate_queryset(queryset=book_list, request=request, view=self)

        ret = BookSerializer(page_article, many=True)<br />
        # return Response(ret.data)<br />
        # 返回带超链接 需返回的时候用内置的响应方法<br />
        return page_obj.get_paginated_response(ret.data)</pre>
</div>
<p>视图</p></div>
<h4>第三种 CursorPagination 加密游标的分页 把上一页和下一页的id记住</h4>
<div>
<div>
<pre class="prettyprint linenums">class MyCursorPagination(CursorPagination):<br />
    cursor_query_param = 'cursor'<br />
    page_size = 1<br />
    ordering = '-id'</pre>
</div>
<p>自定义分页类</p></div>
<div>
<div>
<pre class="prettyprint linenums">class BookView(APIView):<br />
    def get(self, request):<br />
        book_list = Book.objects.all()<br />
        # 分页<br />
        page_obj = MyCursorPagination()<br />
        page_article = page_obj.paginate_queryset(queryset=book_list, request=request, view=self)

        ret = BookSerializer(page_article, many=True)<br />
        # return Response(ret.data)<br />
        # 返回带超链接 需返回的时候用内置的响应方法<br />
        return page_obj.get_paginated_response(ret.data)</pre>
</div>
<p>视图</p></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m967y7v8.html">SQL SELECT INTO使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r0dem9.html">hibernate的session对象核心方法注意的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mwlrpq.html">ubuntu10&period;04&period;4下安装JDK</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8myj228.html">收藏的  500多个开源的Git源码</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93gg0w8.html">EasyUI使用tree方法生成树形结构加载两次的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4vjn0q.html">php&lowbar;match&sol;preg&lowbar;match&lowbar;all 默认有字符串长度限制</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jovk0q.html">Android支付之支付宝封装类</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mox1xq.html">docker  数据共享，数据复制</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mndv2rq.html">MyBatis学习总结&lowbar;13&lowbar;Mybatis查询之resultMap和resultType区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okgxke9.html">ADO和DAO的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdwzez8.html">Java线程池学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wgyolq.html">spring aop配置及用例说明（3）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1e02x9.html">jquery中 cache&colon; true和false的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m34xkq.html">Java常见异常总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xrjpz9.html">【转】SVN&colon;Android Studio设置忽略文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x5n5r9.html">安装gVim</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd222d9.html">CentOs7相对于CentOs6的常用命令变化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8megd7oq.html">RCTF 2017 easyre-153</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z4lxk9.html">Python学习之路&mdash;&mdash;迭代器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meogy2q.html">Linux高效数据统计命令wc</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8m2dmn0q.html">SQL 显示表名显示列名</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wjo10q.html">学习用Node&period;js和Elasticsearch构建搜索引擎（4）&colon; 构建Elasticsearch搜索引擎</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1ezzw9.html">Palindromic characteristics CodeForces - 835D （区间DP，预处理回文串问题）</a>
			</li>
						<li><a href="https://www.batexi.com/a/960mpdj9.html">批量采集世纪佳缘会员图片及winhttp异步采集效率</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlloloeq.html">javascript重定向页面并用post方法传递消息</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw5wyx9.html">fileInput插件上传文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyvkpd9.html">Column &amp;&num;39&semi;parent&lowbar;id&amp;&num;39&semi; specified twice</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw55k09.html">connect、resource和dba三种标准角色</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy22njq.html">C&bsol;C&plus;&plus;学习笔记 1</a>
			</li>
						<li><a href="https://www.batexi.com/a/960mmw39.html">C&num;设计模式之9：模板方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
